<?php
function wsesp_paginate($reload, $page, $tpages) {
    $adjacents = 2;
    $prevlabel = "&lsaquo; Prev";
    $nextlabel = "Next &rsaquo;";
    $out = "";
    // previous
    if ($page == 1) {
        $out.= "<span>" . $prevlabel . "</span>\n";
    } elseif ($page == 2) {
        $out.= "<li><a  href=\"" . $reload . "\">" . $prevlabel . "</a>\n</li>";
    } else {
        $out.= "<li><a  href=\"" . $reload . "&amp;page=" . ($page - 1) . "\">" . $prevlabel . "</a>\n</li>";
    }

    $pmin = ($page > $adjacents) ? ($page - $adjacents) : 1;
    $pmax = ($page < ($tpages - $adjacents)) ? ($page + $adjacents) : $tpages;
    for ($i = $pmin; $i <= $pmax; $i++) {
        if ($i == $page) {
            $out.= "<li  class=\"active\"><a href=''>" . $i . "</a></li>\n";
        } elseif ($i == 1) {
            $out.= "<li><a  href=\"" . $reload . "\">" . $i . "</a>\n</li>";
        } else {
            $out.= "<li><a  href=\"" . $reload . "&amp;page=" . $i . "\">" . $i . "</a>\n</li>";
        }
    }

    if ($page < ($tpages - $adjacents)) {
        $out.= "<a style='font-size:11px' href=\"" . $reload . "&amp;page=" . $tpages . "\">" . $tpages . "</a>\n";
    }
    // next
    if ($page < $tpages) {
        $out.= "<li><a  href=\"" . $reload . "&amp;page=" . ($page + 1) . "\">" . $nextlabel . "</a>\n</li>";
    } else {
        $out.= "<span style='font-size:11px'>" . $nextlabel . "</span>\n";
    }
    $out.= "";
    return $out;
}

function wsesp_populate_categories_dropdown()
{
    
    global $wpdb;
    $categories = array();
    
    $query_categories = "SELECT {$wpdb->prefix}terms.*  
  FROM {$wpdb->prefix}terms  
  LEFT JOIN {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}terms.term_id = {$wpdb->prefix}term_taxonomy.term_id 
  WHERE {$wpdb->prefix}term_taxonomy.taxonomy = 'product_cat'";
    
    foreach ($wpdb->get_results($query_categories) as $key => $row) {
        
        $categories[] = $row;
    }
    
    return $categories;
    
    
    
}

function wsesp_generate_products_table()
{

     
$path = plugins_url('', __FILE__);
    
    global $wpdb;
    
    $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date']) || ($_GET['start_date'] != '' && $_GET['end_date'] != '')) {
        
        
        $start_date = sanitize_title($_GET['start_date']);
        $end_date   = sanitize_title($_GET['end_date']);
        
    }
    $active = '0';
    $status_check =   wsesp_status_check();
    $trials = wsesp_product_type();
    $today1 = time(); 
    $expp = $trials['expiry'];
    $p_type = $trials['type'];
    if($p_type == '1'){

        $product_info = 'WooCommerce Product and Stock Manager Pro';

    }
    else if($p_type == '2') {

        $product_info = 'WooCommerce Product and Stock Manager Trial';
    }
    else {

        $product_info = 'WooCommerce Product and Stock Manager';
    }

    if(($today1 < $expp) && $p_type == 2){

        $try = '1';
    }

    else {

        $try = '0';
    }

  
  
    if(($p_type == '1' && $status_check['check'] == 'active') || ($p_type == '2' && $status_check['check'] == 'active' && $try == '1')){

          $active = '1';

    }

    else{

         $active = '0';
    }



    $query_stock_1 = "SELECT COUNT(*) as count,posts.ID as product_id, posts.post_title as Product_name, stockmeta2.meta_value as Stock_Left, stockmeta3.meta_value AS Stock_Status,  stockmeta8.meta_value as manage_stock, type2.*, {$wpdb->prefix}terms.*, type1.term_taxonomy_id as type FROM {$wpdb->prefix}posts as posts  

LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta2 ON stockmeta2.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta3 ON stockmeta3.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta8 ON stockmeta8.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}term_relationships as type2 ON type2.object_id = posts.ID 
LEFT JOIN {$wpdb->prefix}term_relationships as type1 ON type1.object_id = posts.ID  
LEFT JOIN(SELECT term_taxonomy_id as tid FROM {$wpdb->prefix}term_taxonomy WHERE taxonomy IN('product_cat')) {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}term_taxonomy.tid = type2.term_taxonomy_id  
LEFT JOIN {$wpdb->prefix}terms ON {$wpdb->prefix}terms.term_id = type2.term_taxonomy_id
       WHERE   posts.post_type   = 'product'  
       AND stockmeta2.meta_key = '_stock'  
       AND stockmeta3.meta_key = '_stock_status' 
       AND stockmeta8.meta_key = '_manage_stock' 
       ";
        
    
    
    if ($_GET['category'] && $_GET['category'] != 'All' && $_GET['category'] != '') {
        
        $query_stock_1 .= "AND type2.term_taxonomy_id = '{$_GET['category']}'";
        
        
    }
    
    if ($_GET['type'] && $_GET['type'] != 'all' && $_GET['type'] != '') {
        
        $query_stock_1 .= "AND type1.term_taxonomy_id = '{$_GET['type']}'";
        
        
    }
    
    if ($_GET['manage'] && $_GET['manage'] != 'all' && $_GET['manage'] != '') {
        
        $query_stock_1 .= "AND stockmeta8.meta_value = '{$_GET['manage']}'";
        
        
    }
    
    if ($_GET['stock'] && $_GET['stock'] != 'all' && $_GET['stock'] != '') {
        
        $query_stock_1 .= "AND stockmeta3.meta_value = '{$_GET['stock']}'";
        
        
    }
   
    $query_stock_1 .= " GROUP BY product_id ";

if(isset($_POST['records_value'])){

    $rec = $_POST['rec_value'];
 $table_name = $wpdb->prefix . 'woostocksmanager_data';
$wpdb->query("UPDATE $table_name SET rec_value = '$rec' WHERE 1");

}
$get_rec = "SELECT rec_value FROM {$wpdb->prefix}woostocksmanager_data";
$get_rec_value = $wpdb->get_var($get_rec);

if($get_rec_value > 0 || $get_rec_value != ''){

    $recordsPerPage = $get_rec_value;
}

else {

    $recordsPerPage = 10;
}

     $abcp = $wpdb->get_results($query_stock_1);
    $count = $wpdb->num_rows;
    

$page = (int) (!isset($_REQUEST['page-no']) ? 1 :$_REQUEST['page-no']);
$page = ($page == 0 ? 1 : $page);

$start = ($page-1) * $recordsPerPage;
$adjacents = "2";
 
$prev = $page - 1;
$next = $page + 1;
$lastpage = ceil($count/$recordsPerPage);

$lpm1 = $lastpage - 1;   
$pagination = "";
if($lastpage > 1)
    {   
        $pagination .= "<div class='pagination'>";
        if ($page > 1)
            $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($prev)."\">&laquo; Previous&nbsp;&nbsp;</a>";
        else
            $pagination.= "<span class='disabled'>&laquo; Previous&nbsp;&nbsp;</span>";   
        if ($lastpage < 7 + ($adjacents * 2))
        {   
            for ($counter = 1; $counter <= $lastpage; $counter++)
            {
                if ($counter == $page)
                    $pagination.= "<span class='current'>$counter</span>";
                else
                    $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($counter)."\" >$counter</a>";     
 
            }
        }   
 
        elseif($lastpage > 5 + ($adjacents * 2))
        {
            if($page < 1 + ($adjacents * 2))
            {
                for($counter = 1; $counter < 4 + ($adjacents * 2); $counter++)
                {
                    if($counter == $page)
                        $pagination.= "<span class='current'>$counter</span>";
                    else
                        $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($counter)."\">$counter</a>";     
                }
                $pagination.= "...";
                $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($lpm1)."\" >$lpm1</a>";
                $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($lastpage)."\" >$lastpage</a>";   
 
           }
           elseif($lastpage - ($adjacents * 2) > $page && $page > ($adjacents * 2))
           {
               $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=\"1\"\" >1</a>";
               $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=\"2\"\" >2</a>";
               $pagination.= "...";
               for($counter = $page - $adjacents; $counter <= $page + $adjacents; $counter++)
               {
                   if($counter == $page)
                       $pagination.= "<span class='current'>$counter</span>";
                   else
                       $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($counter)."\" >$counter</a>";     
               }
               $pagination.= "..";
               $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($lpm1)."\" >$lpm1</a>";
               $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($lastpage)."\" >$lastpage</a>";   
           }
           else
           {
               $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=\"1\"\" >1</a>";
               $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=\"2\"\" >2</a>";
               $pagination.= "..";
               for($counter = $lastpage - (2 + ($adjacents * 2)); $counter <= $lastpage; $counter++)
               {
                   if($counter == $page)
                        $pagination.= "<span class='current'>$counter</span>";
                   else
                        $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($counter)."\">$counter</a>";     
               }
           }
        }
        if($page < $counter - 1)
            $pagination.= "<a href=\"admin.php?page=Woo-Stocks-Manager&page-no=".($next)."\">Next &raquo;</a>";
        else
            $pagination.= "<span class='disabled'>Next &raquo;</span>";
 
        $pagination.= "</div>";       
    }
 
if(isset($_POST['page-no']) && !empty($_POST['page-no']))
{
    $id=$_POST['page-no'];
}
else
{
    $id='0';
}


$limit = 'LIMIT ' .$start .',' .$recordsPerPage;
      
    
    
    $query_stock = "SELECT COUNT(*) as count,posts.ID as product_id, posts.post_title as Product_name, stockmeta2.meta_value as Stock_Left, stockmeta3.meta_value AS Stock_Status, stockmeta4.meta_value as sku, stockmeta5.meta_value as weight, ROUND(stockmeta6.meta_value, 2) as regular_price, ROUND(stockmeta7.meta_value, 2) as sale_price, stockmeta8.meta_value as manage_stock, stockmeta9.meta_value as backorders, type2.*, {$wpdb->prefix}terms.*, type1.term_taxonomy_id as type FROM {$wpdb->prefix}posts as posts  

LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta2 ON stockmeta2.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta3 ON stockmeta3.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta4 ON stockmeta4.post_id = posts.ID 
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta5 ON stockmeta5.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta6 ON stockmeta6.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta7 ON stockmeta7.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta8 ON stockmeta8.post_id = posts.ID  
LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta9 ON stockmeta9.post_id = posts.ID 
LEFT JOIN {$wpdb->prefix}term_relationships as type2 ON type2.object_id = posts.ID 
LEFT JOIN {$wpdb->prefix}term_relationships as type1 ON type1.object_id = posts.ID  
LEFT JOIN(SELECT term_taxonomy_id as tid FROM {$wpdb->prefix}term_taxonomy WHERE taxonomy IN('product_cat')) {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}term_taxonomy.tid = type2.term_taxonomy_id  
LEFT JOIN {$wpdb->prefix}terms ON {$wpdb->prefix}terms.term_id = type2.term_taxonomy_id
       WHERE   posts.post_type   = 'product'  
       AND stockmeta2.meta_key = '_stock'  
       AND stockmeta3.meta_key = '_stock_status' 
       AND stockmeta4.meta_key = '_sku' 
       AND stockmeta5.meta_key = '_weight' 
       AND stockmeta6.meta_key = '_regular_price' 
       AND stockmeta7.meta_key = '_sale_price' 
       AND stockmeta8.meta_key = '_manage_stock' 
       AND stockmeta9.meta_key = '_backorders'";
        
    
    
    if ($_GET['category'] && $_GET['category'] != 'All' && $_GET['category'] != '') {
        
        $query_stock .= "AND type2.term_taxonomy_id = '{$_GET['category']}'";
        
        
    }
    
    if ($_GET['type'] && $_GET['type'] != 'all' && $_GET['type'] != '') {
        
        $query_stock .= "AND type1.term_taxonomy_id = '{$_GET['type']}'";
        
        
    }
    
    if ($_GET['manage'] && $_GET['manage'] != 'all' && $_GET['manage'] != '') {
        
        $query_stock .= "AND stockmeta8.meta_value = '{$_GET['manage']}'";
        
        
    }
    
    if ($_GET['stock'] && $_GET['stock'] != 'all' && $_GET['stock'] != '') {
        
        $query_stock .= "AND stockmeta3.meta_value = '{$_GET['stock']}'";
        
        
    }
   
    $query_stock .= " GROUP BY product_id ".$limit;
 
  

    foreach ($wpdb->get_results($query_stock) as $key => $row) {
       
        
        $pro = $row->product_id;
       
        
        $type_query = "SELECT {$wpdb->prefix}terms.name FROM {$wpdb->prefix}term_relationships 
  LEFT JOIN {$wpdb->prefix}posts  ON {$wpdb->prefix}term_relationships.object_id = {$wpdb->prefix}posts.ID 
  LEFT JOIN {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}term_taxonomy.term_taxonomy_id = {$wpdb->prefix}term_relationships.term_taxonomy_id 
  LEFT JOIN {$wpdb->prefix}terms ON {$wpdb->prefix}terms.term_id = {$wpdb->prefix}term_relationships.term_taxonomy_id 
  WHERE post_type = 'product' AND taxonomy = 'product_type'  
  AND  object_id = '{$pro}'";
        
        $var_sql = "SELECT ID FROM `wp_posts` WHERE post_type = 'product_variation' AND post_parent = '{$pro}'";

        $var_id = $wpdb->get_var($var_sql);
        if($var_id == null || $var_id == ''){
            $var_id1[] = "No";
        }
        else{
            $var_id1[] = "Yes";
        }
        

        $product[]  = $row->Product_name;
        
        $type[]   = $wpdb->get_var($type_query);
        $pro_id[] = $row->product_id;
        $sku[]    = $row->sku;
        if ($row->Stock_Status == 'instock') {
            $s_status[] = "In";
        } else {
            $s_status[] = "Out";
        }
        
       
      
        if ($row->Stock_Left == null) {
           $left[] = "";
        } else {
            $left[] = $row->Stock_Left;
        }
        $weight[]        = $row->weight;
        $regular_price[] = $row->regular_price;
        $sale_price[]    = $row->sale_price;
        $manage_stock[]  = $row->manage_stock;
        if ($row->backorders == 'no') {
            $backorders[] = "Do not Allow";
        } elseif ($row->backorders == 'yes') {
            $backorders[] = "Allow";
        }
        
        else {
            
            $backorders[] = "Allow,but notify";
        }
        

      
    } 
    
 


?>
    <div class="custom_form_container">
        <div class="row">
            <div class="col-md-1 config-holder">
                <a id="menu-toggle" href="#" class="btn btn-primary btn-lg toggle filter_icon"><i class="glyphicon glyphicon-menu-hamburger"></i></a>
                <div id="sidebar-wrapper">
                    <ul class="sidebar-nav">
                        <a id="menu-close" href="#" class="btn btn-default btn-lg pull-right toggle"> <i class="glyphicon glyphicon-remove filter_close">
    </i> </a>
                        <li class="sidebar-brand"> <a href="#">Filters
    </a> </li>
                        <li>
                            <?php // $trials=wsesp_product_type(); ?>
                            <?php // $today1=time(); $expp=$trials[ 'expiry']; $try=0 ; if($today1 < $expp){ $try=1 ; } ?>
                            <?php // $status_check=wsesp_status_check(); if (($status_check[ 'activated']=="active" ) || ($status_check[ 'check']=="active" ) ) { ?>
                            <form method="GET" class="date_range_form">
                                <!-- Category Filter -->
                                <div class="form-group custom_form_group">
                                    <label class="control-label woochart_label_activated" for="date">Product Category </label>
                                </div>
                                <select name="category" class="pfilter" id="c_filter">
                                    <option value="">SELECT </option>
                                    <option value="All" <?php if ($_GET['category'] == All) echo 'selected'; ?>>All </option>
                                    <?php $categories_filter=wsesp_populate_categories_dropdown(); foreach ($categories_filter as $key=> $value) { ?>
                                    <option value="<?php echo $value->term_id; ?>" <?php if ($_GET['category'] == $value->term_id) echo 'selected'; ?>>
                                        <?php echo $value->name; ?> </option>
                                    <?php } ?> </select>
                                <!-- End Category Filter -->
                                <!--  Type Filter -->
                                <div class="form-group custom_form_group">
                                    <label class="control-label woochart_label_activated">Product Data </label>
                                </div>
                                <select name="type" class="pfilter" id="c_filter">
                                    <option value="">SELECT </option>
                                    <option value="all"  <?php if ($_GET['type'] == all) echo 'selected'; ?>>All </option>
                                    <option value="2"  <?php if ($_GET['type'] == 2) echo 'selected'; ?>>Simple Product </option>
                                    <option value="3"  <?php if ($_GET['type'] == 3) echo 'selected'; ?>>Grouped Product </option>
                                    <option value="4"  <?php if ($_GET['type'] == 4) echo 'selected'; ?>>Variable Product </option>
                                    <option value="5"  <?php if ($_GET['type'] == 5) echo 'selected'; ?>>External/Affiliate Product </option>
                                </select>
                                <!-- End Type Filter -->
                                <!--  Manage Stock Filter -->
                                <div class="form-group custom_form_group">
                                    <label class="control-label woochart_label_activated">Manage Stock </label>
                                </div>
                                <select name="manage" class="pfilter" id="c_filter">
                                    <option value="">SELECT </option>
                                    <option value="all" <?php if ($_GET['manage'] == all) echo 'selected'; ?>>All </option>
                                    <option value="yes" <?php if ($_GET['manage'] == yes) echo 'selected'; ?>>Yes </option>
                                    <option value="no" <?php if ($_GET['manage'] == no) echo 'selected'; ?>>No </option>
                                </select>
                                <!--  End Manage Stock Filter -->
                                <!--  Stock Status Filter -->
                                <div class="form-group custom_form_group">
                                    <label class="control-label woochart_label_activated">Stock Status </label>
                                </div>
                                <select name="stock" class="pfilter" id="c_filter">
                                    <option value="">SELECT </option>
                                    <option value="all" <?php if ($_GET['stock'] == all) echo 'selected'; ?>>All </option>
                                    <option value="instock" <?php if ($_GET['stock'] == instock) echo 'selected'; ?>>In Stock </option>
                                    <option value="outofstock" <?php if ($_GET['stock'] == outofstock) echo 'selected'; ?>>Out of Stock </option>
                                </select>
                                <!--  End Stock Status Filter -->
                                <input type="hidden" name="page" value="Woo-Stocks-Manager" />
                               <!-- <input type="hidden" name="range" value="custom" /> -->
                                <button class="btn btn-primary " name="submit" type="submit" id="submit_custom">Submit </button>
                            </form>
                        </li>
                    </ul>
                </div>
            </div>
            <div class="col-md-6">
                <h2 class="logo"><?php echo $product_info; ?></h2>
            </div>
            <div class="col-md-5">
                <?php if( ($active == '0' && $p_type == '1') || ($active == '0' && $p_type == '') ){ ?>
                <p class="license_pro_button"><a href="https://www.essentialplugins.com/woo-stocks-manager/" class="pro_link buy_pro settings-btn" target="_blank" style="padding: 6px;font-size: 24px !important;">BUY PRO</a></p>
                <p class="license_pro">Buy Pro Version to Enable Editing</p>
                <?php }
               if($p_type == '2' && $try == '1' && $active == '1'){
        echo '<p class="license_pro_button"><a href="https://www.essentialplugins.com/woo-stocks-manager/" class="pro_link buy_pro settings-btn" target="_blank" style="padding: 6px;font-size: 24px !important;">BUY PRO</a></p>';
        echo '<p class="license_pro">Your trial expires on '.date('d M, Y', $expp).'</p>';
    }

    if($p_type == '2' && $try == '0' && $active == '0') {
        echo '<p class="license_pro_button"><a href="https://www.essentialplugins.com/woo-stocks-manager/" class="pro_link buy_pro settings-btn" target="_blank" style="padding: 6px;font-size: 24px !important;">BUY PRO</a></p>';
        echo '<p class="license_pro">Your trial expired on '.date('d M, Y', $expp).'</p>';

    }?>
            </div>
        </div>
    </div>
    <div class="charts" style="display:inline-block; width: 100%">
        <div class="chart-container nine">
            <table id="product_info" class="display stripe" width="100%">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>Product Name</th>
                        <th>Product Category</th>
                        <tH>Product Data</th>
                        <th>Variation</th>
                       
                      
                        <th>Regular Price</th>
                        <th>Sale Price</th>
                        <th>SKU</th>
                        <th>Weight</th>
                        <th>Manage Stock</th>
                        <th>Stock Quantity</th>
                        <th>Backorders</th>
                        <th>Stock Status</th>
                    </tr>
                </thead>
                <tbody>
                    <?php if($product){foreach ($product as $key => $value) { 
                        if($active == '1'){

                        ?>
                    <tr>
                        <td>
                            <?php echo $pro_id[$key]; ?>
                        </td>
                        <td class="details-control">
                           <a href="post.php?post=<?php echo $pro_id[$key]; ?>&action=edit" target="_blank"><?php echo $value; ?></a>
                        </td>
                        <td id="select<?php echo $pro_id[$key]; ?>">
                            <select name="category[]" multiple class="pro_cat multicat" id="<?php echo $pro_id[$key]; ?>">
                                <?php  
                              $categories_filter = wsesp_populate_categories_dropdown();
                              foreach ($categories_filter as $value1) {

            $c_query = "SELECT COUNT(*) FROM {$wpdb->prefix}term_relationships WHERE object_id = '{$pro_id[$key]}' AND term_taxonomy_id = '{$value1->term_id}' ";

            $rowcount = $wpdb->get_var($c_query);
           
                               ?>
                                <option value="<?php echo $value1->term_id; ?>" <?php if($rowcount > 0){echo "selected";} ?> >
                                    <?php echo $value1->name; ?>
                                </option>
                                <?php    }

 ?>
                            </select>
                        </td>
                        <td contenteditable="true">
                            <select name="type" class="pro_cat" onchange="saveToDatabase_category(this,'type','<?php echo $pro_id[$key]; ?>');" onClick="showEdit(this);">
                                <option value="" disabled selected="true">
                                    <?php echo ucfirst($type[$key]); ?>
                                </option>
                                <option disabled>--------</option>
                                <option value="2">Simple</option>
                                <option value="3">Grouped</option>
                                <option value="4">Variable</option>
                                <option value="5">Ext/Aff</option>
                            </select>
                        </td>
                        <?php if($var_id1[$key] == 'Yes'){ ?>
                        <td class="edit_var">
                            <button class="var_button btn">Show Variation</button>
                        </td>
                        <?php  } else {?>
                        <td>-</td>
                        <?php } ?>
                      <!--  <td>
                            <?php echo $sold[$key]; ?>
                        </td>
                        <td>
                            <?php echo $sales[$key]; ?>
                        </td> -->
                        <td contenteditable="<?php if($type[$key]=='variable' || $type[$key]=='grouped'){ echo "false";} else {echo "true";} ?>" id="regular-<?php echo $pro_id[$key]; ?>" onBlur="saveToDatabase(this,'regular_price','<?php echo $pro_id[$key]; ?>')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">
                            <?php echo '$'.$regular_price[$key]; ?> </td>
                        <td contenteditable="<?php if($type[$key]=='variable' || $type[$key]=='grouped'){ echo "false";} else {echo "true";} ?>" id="sale-<?php echo $pro_id[$key]; ?>" onBlur="saveToDatabase(this,'sale_price','<?php echo $pro_id[$key]; ?>')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">
                            <?php echo '$'.$sale_price[$key]; ?>
                        </td>
                        <td contenteditable="true" onBlur="saveToDatabase(this,'sku','<?php echo $pro_id[$key]; ?>')" onClick="showEdit(this);">
                            <?php echo $sku[$key]; ?>
                        </td>
                       
                        <td contenteditable="<?php if($type[$key]=='external' || $type[$key]=='grouped'){ echo "false";} else {echo "true";} ?>" id="weight-<?php echo $pro_id[$key]; ?>" onBlur="saveToDatabase(this,'weight','<?php echo $pro_id[$key]; ?>')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">
                            <?php echo $weight[$key]; ?>
                        </td>
                        <td contenteditable="true">
                            <select id="manage-<?php echo $pro_id[$key]; ?>" name="manage_stock" class="pro_cat" <?php if($type[$key]=='external' || $type[$key]=='grouped' ){ echo "disabled";} ?> onchange="saveToDatabase_category(this,'manage_stock','<?php echo $pro_id[$key]; ?>');" onClick="showEdit(this);">
                                <option value="" disabled selected="true">
                                    <?php echo ucfirst($manage_stock[$key]); ?>
                                </option>
                                <option disabled>--------</option>
                                <option value="yes">Yes</option>
                                <option value="no">No</option>
                            </select>
                        </td>
                        <td contenteditable="<?php if($manage_stock[$key] == 'no' || $type[$key] == 'external'){ echo "false";} else {echo "true";} ?>" id="left-<?php echo $pro_id[$key]; ?>" onBlur="saveToDatabase(this,'stock_left','<?php echo $pro_id[$key]; ?>')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">
                            <?php echo $left[$key]; ?>
                        </td>
                        <td contenteditable="true">
                            <select name="backorders" id="back-<?php echo $pro_id[$key]; ?>" <?php if($manage_stock[$key]=='no' || $type[$key]=='external' ){ echo "disabled";} ?> class="pro_cat" onchange="saveToDatabase_category(this,'backorders','<?php echo $pro_id[$key]; ?>');" onClick="showEdit(this);">
                                <option value="" disabled selected="true">
                                    <?php echo $backorders[$key]; ?>
                                </option>
                                <option disabled>--------</option>
                                <option value="yes">Allow</option>
                                <option value="notify">Allow,but notify</option>
                                <option value="no">Do not allow</option>
                            </select>
                        </td>
                         <td contenteditable="true">
                            <select name="s_status" id="status-<?php echo $pro_id[$key]; ?>" class="pro_cat" <?php if($type[$key]=='external' || $type[$key]=='variable' ){ echo "disabled";} ?> onchange="saveToDatabase_category(this,'s_status','<?php echo $pro_id[$key]; ?>');" onClick="showEdit(this);">
                                <option value="" disabled selected="true">
                                    <?php echo $s_status[$key]; ?>
                                </option>
                                <option disabled>--------</option>
                                <option value="instock">In</option>
                                <option value="outofstock">Out</option>
                            </select>
                        </td>
                    </tr>
                    <?php } 

                        else { ?>
                    <tr>
                        <td>
                            <?php echo $pro_id[$key]; ?>
                        </td>
                        <td class="details-control">
                             <a href="post.php?post=<?php echo $pro_id[$key]; ?>&action=edit" target="_blank"><?php echo $value; ?></a>
                        </td>
                        <td>
                                <?php  
                              $categories_filter = wsesp_populate_categories_dropdown();
                              foreach ($categories_filter as $value1) {

            $c_query = "SELECT COUNT(*) FROM {$wpdb->prefix}term_relationships WHERE object_id = '{$pro_id[$key]}' AND term_taxonomy_id = '{$value1->term_id}' ";

            $rowcount = $wpdb->get_var($c_query);
            if($rowcount > 0){

                echo $value1->name.","; 

            }
           
                            }

 ?>
                        </td>
                        <td>
                            <?php echo ucfirst($type[$key]); ?>
                        </td>
                        <?php if($var_id1[$key] == 'Yes'){ ?>
                        <td class="edit_var">
                            <button class="var_button btn">Show Variation</button>
                        </td>
                        <?php  } else {?>
                        <td>-</td>
                        <?php } ?>
                       <!-- <td>
                            <?php echo $sold[$key]; ?>
                        </td>
                        <td>
                            <?php echo $sales[$key]; ?>
                        </td> -->
                        <td>
                            <?php echo '$'.$regular_price[$key]; ?> </td>
                        <td>
                            <?php echo '$'.$sale_price[$key]; ?>
                        </td>
                        <td>
                            <?php echo $sku[$key]; ?>
                        </td>
                        <td>
                            <?php echo $s_status[$key]; ?>
                        </td>
                        <td>
                            <?php echo $weight[$key]; ?>
                        </td>
                        <td>
                            <?php echo ucfirst($manage_stock[$key]); ?>
                        </td>
                        <td>
                            <?php echo $left[$key]; ?>
                        </td>
                        <td>
                            <?php echo $backorders[$key]; ?>
                        </td>
                    </tr>
                    <?php } } }?>
                </tbody>
            </table>
            <div class="table-controls">
            <form method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>" id="records_form">
                    <label class="rec_label">Show</label>
                    <input type="number" placeholder="No. of records to be shown" name="rec_value" />
                    <label class="rec_label">Entries</label>
                    <input type="submit" name="records_value" value="Save" id="submit_custom2" class="btn" />
                </form>
                            
          
   <?php    echo $pagination;

            ?>
        </div>
        </div>
    </div>
    
  
    <script>
    jQuery("#sidebar-wrapper").addClass("active");

    jQuery("#menu-close").click(function(e) {
        e.preventDefault();
        jQuery("#sidebar-wrapper").toggleClass("active");
    });

    jQuery("#menu-toggle").click(function(e) {
        e.preventDefault();
        jQuery("#sidebar-wrapper").toggleClass("active");

    });
    </script>
    <script>

    var $ = jQuery;
    $(document).ready(function () {
            $('.multicat').SumoSelect({
            okCancelInMulti: true, 
            csvDispCount: 4,
            showTitle: false,

            });
     });

    $('.multicat').on('change', function(event){
        event.preventDefault();
        var form_data = $(this).val();
       
        var column = "category";
        var id = $(this).attr('id');
        var div = "#select" + id;
        
        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: { action: 'wsesp_inline_products', column: column, editval: form_data, id: id },
            dataType: "json"
        }).done(function(response) {
            


            if (response == 'Success') {

                    setTimeout(function() { $(div).css("background", "#91f50d"); }, 300);
                    setTimeout(function() { $(div).css("background", "rgba(39, 255, 0, 0.30980392156862746)"); }, 4000);
               
             


            }  else {

                setTimeout(function() { $(div).css("background", "red"); }, 300);
                setTimeout(function() { $(div).css("background", "rgba(255, 0, 0, 0.2901960784313726)"); }, 4000);
                
              
            }


        });
    });

    
   
    var active = <?php echo $active; ?>;
          


    var table = $('#product_info').DataTable({
        "pageLength": 25,
        "sDom": '<"top"if>rt<"bottom1"pl><"clear">',
         "bPaginate": false,
    "bLengthChange": false,

        "order": [
            [1, "asc"]
        ]
    });
    function closeVar() {
             if (confirm('Please refresh this page to view the changes you made (if any) to the variation table.')) {
            
            location.reload();
}      
    
}
    $('#product_info tbody').on('click', 'td.edit_var', function() {
        var tr = $(this).closest('tr');
        var row = table.row(tr);

        $(this).html('<button class="var_button btn">Show Variation</button>');
        if (row.child.isShown()) {
            // This row is already open - close it

            $('div.slider', row.child()).slideUp(function() {
                row.child.hide();

                tr.removeClass('shown');
            });
        } else {
            
            $(this).html('<button class="var_button btn">Close Variation</button>');

            var trs = '';
            var pdata = '';
            var parent = row.data()[0];
           
           var json;
          
        var edit = 'false';
        var parent_name;
        var disabled_attr = 'disabled';

          $.ajax({
            type: "POST",
            url: ajaxurl,
            data: { action: 'wsesp_get_variation_data', parent: parent },
        }).done(function(response) {
           
           json = response;
       $.each(json, function(i, item) {

            
                parent_name = json[i].parent_product;
                

                if (json[i].Stock_Status == 'instock' || json[i].Stock_Status == 'In') {
                    json[i].Stock_Status = "In";
                } else {
                    json[i].Stock_Status = "Out";
                }

                 if (json[i].Stock_Left == null) {
                    json[i].Stock_Left = "";
                } else {
                    json[i].Stock_Left = json[i].Stock_Left;
                }

                if (json[i].manage_stock == 'yes' || json[i].manage_stock == 'Yes') {
                    json[i].manage_stock = "Yes";
                    edit = "true";
                    disabled_attr = '';
                } else {
                    json[i].manage_stock = "No";
                    edit = "No";
                    disabled_attr = 'disabled';
                }

                if (json[i].backorders == 'no' || json[i].backorders == 'Do not Allow') {
                    json[i].backorders = "Do not Allow";
                } else if (json[i].backorders == 'yes' || json[i].backorders == 'Allow') {
                    json[i].backorders = "Allow";
                } else {

                    json[i].backorders = "Allow,but notify";
                }

                if (active == '1') {
                    trs += '<tr>' +
                        '<td>' + json[i].product_id + '</td>' +
                        '<td>' + json[i].parent_product + ' - ' + json[i].attribute + '</td>' +
                        '<td contenteditable="true" onBlur="saveToDatabase(this,\'regular_price\',' + json[i].product_id + ')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">' + json[i].regular_price + '</td>' +
                        '<td contenteditable="true" onBlur="saveToDatabase(this,\'sale_price\',' + json[i].product_id + ')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">' + json[i].sale_price + '</td>' +
                        '<td contenteditable="true" onBlur="saveToDatabase(this,\'sku\',' + json[i].product_id + ')" onClick="showEdit(this);">' + json[i].sku + '</td>' +
                     

                        '<td contenteditable="true" onBlur="saveToDatabase(this,\'weight\',' + json[i].product_id + ')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">' + json[i].weight + '</td>' +

                        '<td contenteditable="true"><select id="manage-' + json[i].product_id + '" name="manage_stock" class="pro_cat" onchange="saveToDatabase_category(this,\'manage_stock\',' + json[i].product_id + ');" onClick="showEdit(this);">' +
                        '<option value="" disabled selected="true">' +
                        json[i].manage_stock +
                        '</option>' +
                        '<option disabled>--------</option>' +
                        '<option value="yes">Yes</option>' +
                        '<option value="no">No</option>' +
                        '</select>' +
                        '</td>' +


                        '<td contenteditable = "' + edit + '" id="left-' + json[i].product_id + '" onBlur="saveToDatabase(this,\'stock_left\',' + json[i].product_id + ')" onClick="showEdit(this);" onkeypress="return isNumberKey(event)">' + json[i].Stock_Left + '</td>' +
                        '<td contenteditable = "true">' +
                        '<select ' + disabled_attr + ' name="backorders" id="back-' + json[i].product_id + '"class="pro_cat" onchange="saveToDatabase_category(this,\'backorders\',' + json[i].product_id + ');" onClick="showEdit(this);">' +
                        '<option value="" disabled selected="true">' +
                        json[i].backorders +
                        '</option>' +
                        '<option disabled>--------</option>' +
                        '<option value="yes">Allow</option>' +
                        '<option value="notify">Allow,but notify</option>' +
                        '<option value="no">Do not allow</option>' +
                        '</select>' +
                        '</td>' +
                        '<td contenteditable="true"><select name="s_status" id="status_var-' + json[i].product_id + '" class="pro_cat" onchange="saveToDatabase_category(this,\'s_status\',' + json[i].product_id + ');" onClick="showEdit(this);">' +
                        '<option value="" disabled selected="true">' +
                        json[i].Stock_Status +
                        '</option>' +
                        '<option disabled>--------</option>' +
                        '<option value="instock">In</option>' +
                        '<option value="outofstock">Out</option>' +
                        '</select>' +
                        '</td>' +
                        '</tr>';
                } else {

                    trs += '<tr>' +
                        '<td>' + json[i].product_id + '</td>' +
                        '<td>' + json[i].parent_product + ' - ' + json[i].attribute + '</td>' +
                        '<td>' + json[i].regular_price + '</td>' +
                        '<td>' + json[i].sale_price + '</td>' +
                        '<td>' + json[i].sku + '</td>' +
                      
                        '<td>' + json[i].weight + '</td>' +
                        '<td>' + json[i].manage_stock + '</td>' +
                        '<td>' + json[i].Stock_Left + '</td>' +
                        '<td>' + json[i].backorders + '</td>' +
                          '<td>' + json[i].Stock_Status + '</td>' +


                        '</tr>';
                }
            
        })




     pdata =  '<div class="slider">' +
            '<table id="product_stock" class="display stripe dataTable no-footer">' +
            '<thead><tr>' +
            '<th>ID</th>' +
            '<th>Product Name ('+ parent_name +')</th>' +
            '<th>Regular Price</th>' +
            '<th>Sale Price</th>' +
            '<th>SKU</th>' +
            
            '<th>Weight</th>' +
            '<th>Manage Stock</th>' +
            '<th>Stock Quantity</th>' +
            '<th>Backorders</th>' +
            '<th>Stock Status</th> ' +
            '</tr>' +



            '</thead>' +
            '<tbody class="child_tbody">' + trs +
            '</tbody>' +
            '</table>' +
            '</div>';
 
          row.child(pdata).show();
                  tr.addClass('shown');
                  

            $('div.slider', row.child()).slideDown();
    



        });

       }
    });
    </script>
    <script>
    var $ = jQuery;

    function showEdit(editableObj) {


    }


    function saveToDatabase(editableObj, column, id) {

        if (column == 'regular_price' || column == 'sale_price') {
            var str = editableObj.innerHTML;
            var newval = str.replace("$", "");

        } else {

            var newval = editableObj.innerHTML;
        }

         if(newval == ''){
                    
                   return false;
                    
                }
        
        if(column == 'regular_price' || column == 'sale_price' || column == 'weight' || column == 'stock_left'){

             if(isNaN(newval)){
                alert("Please input a valid numeric value");
                 setTimeout(function() { $(editableObj).css("background", "red"); }, 300);
                                     setTimeout(function() { $(editableObj).css("background", "none"); }, 4000);

                return false;
            }
        }

        $(editableObj).css("background", "url(<?php echo $path." / loaderIcon.gif "; ?>) no-repeat right");
        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: { action: 'wsesp_inline_products', column: column, editval: newval, id: id }
        }).done(function(response) {



            if (response == 'Success') {

                if(newval != ''){
                    
                     setTimeout(function() { $(editableObj).css("background", "#91f50d"); }, 300);
                setTimeout(function() { $(editableObj).css("background", "rgba(39, 255, 0, 0.30980392156862746)"); }, 4000);
                    
                }
           
               
              

            }  else {

                   if(newval != ''){
                     setTimeout(function() { $(editableObj).css("background", "red"); }, 300);
                                     setTimeout(function() { $(editableObj).css("background", "none"); }, 4000);
                 }
            }


        });





    }

    function saveToDatabase_category(editableObj, column, id) {
        $(editableObj).css("background", "url(<?php echo $path." / loaderIcon.gif "; ?>) no-repeat right");
        var newval = editableObj.innerHTML;
          if(newval == ''){
                    
                   return false;
                    
                }

        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: { action: 'wsesp_inline_products', column: column, editval: editableObj.value, id: id }
        }).done(function(response) {


            if (response == 'Success') {
                  setTimeout(function() { $(editableObj).css("background", "#91f50d"); }, 300);
                setTimeout(function() { $(editableObj).css("background", "rgba(39, 255, 0, 0.30980392156862746)"); }, 4000);
                var back = '#back-' + id;
                var manage = '#manage-' + id;
                var left = '#left-' + id;
                var status = '#status-' + id;
                var regular = '#regular-' + id;
                var sale = '#sale-' + id;
                var weight = '#weight-' + id;
                if (column == 'manage_stock') {

                    if (editableObj.value == 'yes') {
                        $(back).prop("disabled", false);
                        $(left).attr("contenteditable", true);
                    } else {
                        $(back).prop("disabled", true);
                        $(left).attr("contenteditable", false);
                    }

                }

                if (column == 'type') {

                    if (editableObj.value == '2') {
                        $(manage).prop("disabled", false);
                        $(left).attr("contenteditable", true);
                        $(status).prop("disabled", false);
                        $(back).prop("disabled", false);
                           $(regular).attr("contenteditable", true);
                        $(sale).attr("contenteditable", true);
                    } else if (editableObj.value == '3') {
                        $(manage).prop("disabled", true);
                        $(left).attr("contenteditable", true);
                        $(status).prop("disabled", false);
                        $(back).prop("disabled", false);
                        $(regular).attr("contenteditable", false);
                        $(sale).attr("contenteditable", false);
                        $(weight).attr("contenteditable", false);

                    } else if (editableObj.value == '4') {
                        $(manage).prop("disabled", false);
                        $(left).attr("contenteditable", true);
                        $(status).prop("disabled", true);
                        $(back).prop("disabled", false);
                        $(regular).attr("contenteditable", false);
                        $(sale).attr("contenteditable", false);
                    } else if (editableObj.value == '5') {

                        $(manage).prop("disabled", true);

                        
                        $(status).prop("disabled", true);
                        
                        $(weight).attr("contenteditable", false);
                           $(regular).attr("contenteditable", true);
                        $(sale).attr("contenteditable", true);
                    }


                }
            } else {

                  setTimeout(function() { $(editableObj).css("background", "red"); }, 300);
                setTimeout(function() { $(editableObj).css("background", "none"); }, 4000);
            }


        });





    }
    $("#product_stock").keypress(function(e) { return e.which != 13; });
    $("#product_info").keypress(function(e) { return e.which != 13; });
    $('.var_tr').hide();

    function variationRow(id) {
        var row = '.var-row-' + id;

        $(row).toggle();

    }

    function isNumberKey(evt)
      {
         var charCode = (evt.which) ? evt.which : event.keyCode
         if (charCode > 31 && (charCode < 46 || charCode > 57))
            return false;

         return true;
      }
    </script>
    <?php } 
 ?>